# Bender ![Version](https://img.shields.io/gem/v/bender-bot.svg?style=flat-square)

Yet another HipChat bot.

Bender hooks into both HipChat and JIRA to report and manage incidents. It uses
quite a number of different APIs, and the workflow is is pretty rigid, so the
configuration is quite painful:

    {
      // NB: You actually can't use comments in your JSON. Such is life.
      "hipchat_token": "asdaf98dfas89fdsa8", // Set HipChat v1 API token
      "hipchat_v2_token": "afiadsaf98fdsa890da908", // Set HipChat v2 API token
      "primary_room_id": "12341234", // Set HipChat primary room ID
      "jid": "1234934_213434@chat.hipchat.com", // Set HipChat JID
      "password": "asd12353521fasfda1243dfs", // Set HipChat password
      "nick": "bender",  // Set HipChat nick name (short)
      "mention": "Bender Rodríguez", // Set HipChat mention name (long)
      "rooms": [ "12341_frys_room@chat.hipchat.com" ], // Set HipChat rooms (comma-separated)
      "database": "/var/data/bender.db", // Set path to application database
      "jira_user": "bender, // Set JIRA username
      "jira_pass": "1dkjasdflhkjaiyuwewqmnqew", // Set JIRA password
      "jira_site": "http://jira", // Set JIRA site
      "jira_project": "INC", // Set JIRA project
      "jira_group": "ops", // Set JIRA group for write mode
      "jira_type": "Incident", // Set JIRA issue type
      "user_refresh": 300, // Set JIRA user refresh rate (seconds)
      "issue_refresh": 5, // Set JIRA issue refresh rate (seconds)
      "group_refresh": 60, // Set JIRA group refresh rate (seconds)
      "room_base_name": "Incidents", // Base name for the primary room
      "prefix": "inc", // Command prefix for bot interactions
      "resolved_transitions": [ "51" ], // State IDs for resolution
      "resolved_state": "(?i-mx:resolve)", // State name regex for resolution
      "closed_transitions": [ "61", "71" ], // State IDs for close
      "closed_state": "(?i-mx:close)", // State name regex for close
      "severities": { // Severities (low to high): short number -> ID
        "1": "1234124",
        "2": "1324564",
        "3": "0393103",
        "4": "1092394",
        "5": "1034937"
      },
      "show_fields": { // JIRA fields to show: ID -> human name
        "summary": "Summary",
        "description": "Description",
        "customfield_12259": "Severity",
        "customfield_12251": "Impact Started",
        "customfield_12232": "Impact Ended",
        "customfield_12253": "Reported By",
        "customfield_12354": "Services Affected",
        "customfield_11255": "Cause",
        "status": "Status",
        "created": "Created",
        "updated": "Updated"
      }
    }
